import processing.core.*; 
import processing.xml.*; 

import processing.opengl.*; 
import ddf.minim.*; 
import oscP5.*; 
import netP5.*; 
import java.util.regex.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class tetris_adventure_3_1_fr_part2 extends PApplet {






PrintWriter output;

final boolean debug=false;

OscP5 oscP5;
NetAddress myRemoteLocation;

Minim minim;
  boolean removeLine,on;
AudioSample move,tombe,tourne,ligne;
AudioPlayer titre;

int _line,_score,_line2,_score2;
final int gridWidth=10; 
final int gridHeight=25;
final int gridHidden=2;
final int gridStartX=40;
final int gridStartY=20;
int speedDelay=1000;    // ms between steps
int grid[][];
int rectWidth, rectHeight;
float timer;
int rectY;
int tetrPosX, tetrPosY, tetrType, tetrRot, tetrSize;
boolean tetrLocked, tetrDownStep, tetrDrop;

int tetrSaved;
boolean tetrCanSave;

final int maxQueue=3;
int tetrQueue[];
int queueX, queueY;
int fade;
boolean gameOver=true,start=true,display2=true,gameOver2=true;
PFont f;
PImage a,b,d,c;
int tim;

public void setup() {
  frame.setTitle("Super Tetris Adventure | Joueur 2"); 
  size (800,600,OPENGL);
noCursor();

  oscP5 = new OscP5(this,12001);
myRemoteLocation = new NetAddress("127.0.0.1",12000);

 minim = new Minim (this);
a = loadImage ("title.png");
b = loadImage ("fond.png");
c = loadImage ("bloc.png");
d = loadImage ("barre.png");
   f= loadFont ("PressStartK-12.vlw");
output = createWriter("score.txt");

move= minim.loadSample("move.wav");
tombe= minim.loadSample("tombe.wav");
tourne= minim.loadSample("tourne.wav");
ligne= minim.loadSample("ligne.wav");
titre= minim.loadFile("tetris.mp3",2048);
  grid = new int[gridWidth][gridHeight];
    textFont (f);
  for (int x=0;x<gridWidth;x++) {
    for (int y=0;y<gridHeight;y++) {
      grid[x][y]=0;
    }
 
  }  
  

  rectWidth = PApplet.parseInt(200/10);
  rectHeight = PApplet.parseInt(400/20);
  queueX = 11+gridStartX+rectWidth*gridWidth;
  queueY = 20;

  tetrQueue = new int[maxQueue];
  for(int i=0;i<maxQueue;i++) {
    tetrQueue[i]=round(random(0,6));
  }
  tetrNew();  
  
  tetrSaved=7;
  tetrCanSave=true;
  timer = millis();
}

public void draw() {
   
    background(128);
 
    

  
  if (!gameOver){ titre.rewind();  titre.pause();
}  
     if (gameOver){titre.play();
}  
   
   if (removeLine){
     println ("mercdssdse");
     on=true;
     


     }
  

    console.draw();
    OscMessage myMessage2 = new OscMessage("/score");
    OscMessage myMessage3 = new OscMessage("/line");
myMessage2.add(_score);
myMessage3.add(_line);
  oscP5.send(myMessage2, myRemoteLocation);
    oscP5.send(myMessage3, myRemoteLocation);
  renderGrid();
  renderQueue();
//fill(128);
//rect(0,0,400,20);
 noTint();
    image (b,0,0);
        fill(255);
  text ("JOUEUR 1",200,520);
  text ("Line: "+_line2,200,550);
 text ("Score: "+_score2,200,570);
 ///
   text ("JOUEUR 2",600,520);
  text ("Line: "+_line,600,550);
 text ("Score: "+_score,600,570);


  console.startGame();
   
       
  if (!gameOver && (millis()>timer+speedDelay || tetrDownStep || tetrDrop)) {
    if (!tetrDrop) {
      tetrStepDown();
   
    } else {
      while (tetrDrop) { // Should be able to move left/right before full Drop. 
        tetrStepDown();
        tetrDrop = tetrCheckMove(0,1);
      }
    }

    tetrDownStep=false;
    tetrDrop=false;
    timer = millis();
  }  

  if (gameOver) {
    tetrLocked=true;
  //  renderGameOver();
    console.gameOver();
   
  }
}

public void renderQueue() {
  
  for(int y=0;y<4;y++) {
    for(int x=0;x<4;x++) {
      switchFillColor(gridTemplate[tetrQueue[0]][0][y][x]);
      image(c,(queueX+x*rectWidth)-210,500+y*rectHeight);
       fill(0,128);
     // rect(3+(queueX+x*rectWidth)-210,3+500+y*rectHeight,rectWidth-6,rectHeight-6); 
   
  }
  }
 
  for(int i=1;i<maxQueue;i++) {
    for(int y=0;y<4;y++) {
      for(int x=0;x<4;x++) {
        int yi = 10+queueY+4*rectHeight+((i-1)*(10+4*(rectHeight/2)));
        switchFillColor(gridTemplate[tetrQueue[i]][0][y][x]);
      //  rect((rectWidth*2)+queueX+x*(rectWidth/2),yi+(y*(rectHeight/2)),rectWidth/2,rectHeight/2);
      }
    }
  }

  int yi = ((gridHeight-gridHidden-4)*rectHeight)-queueY;
  for(int y=0;y<4;y++) {
    for(int x=0;x<4;x++) {
      switchFillColor(gridTemplate[tetrSaved][0][y][x]);
    //  rect(queueX+x*rectWidth,yi+y*rectHeight,rectWidth,rectHeight);
    }
  }
}

public void renderShadow() {
  int xx=tetrPosX;
  int yy=tetrPosY;;
  boolean moveOK=false;
  while (tetrCheckMove(0,1,xx,yy,tetrRot)) {
    yy++;
  }
  
  for(int y=0;y<tetrSize;y++) {
    for(int x=0;x<tetrSize;x++) {
      if (gridTemplate[tetrType][tetrRot][y][x]!=0 && y+yy>=gridHidden) {
        if (gridTemplate[tetrType][tetrRot][y][x]!=0) fill(20);
        rect(gridStartX+(x+xx)*rectWidth,gridStartY+((y+yy-gridHidden)*rectHeight),rectWidth,rectHeight);
      }
    }
  }
}

public void renderGameOver() {
//  textFont(f, 32);
 // fill(255);
 // int x = int(((gridWidth*rectWidth)/2)-(textWidth("ooops...")/2));
 // text("ooops...", x, 295);
}

// Save tetrimino for later
public void tetrSave() {
  int t = tetrSaved;
  tetrSaved = tetrType;
  if (t==7) {
    tetrNew();
  } else {
    tetrNew(t);
    tetrCanSave=false;
  }
}

// Move tetrimino one step down, returns TRUE if has been stopped.
public boolean tetrStepDown() {
  boolean moveOK = tetrCheckMove(0,1);
       ///blocage///
       
  
       if (tetrPosY >= 24){tetrPosY =24; tombe.trigger(); tetrFixToGrid();
      gridCheck();
      tetrNew();
      tetrCanSave=true;} 
  
  
      
  if (moveOK) {
    tetrPosY++;
  } else {
       tombe.trigger();
    if (tetrPosY!=0) {
     
      tetrFixToGrid();
      gridCheck();
      tetrNew();
      tetrCanSave=true;
    } else {
      gameOver=true;
       display=true;
    }
  }

  return !moveOK;
 
}

// General routine that performs Check before moving
public boolean tetrCheckMove(int xm, int ym) {
  return tetrCheckMove(xm, ym, tetrPosX, tetrPosY, tetrRot);
}

public boolean tetrCheckMove(int xm, int ym, int tetrX, int tetrY, int tetrR) {
  boolean moveOK=true;
  int gridC=0;
  if (debug) System.out.println("==");
  for(int y=0;y<tetrSize;y++) {
    for(int x=0;x<tetrSize;x++) {
      if ((tetrY+y+ym<0 || tetrY+y+ym>=gridHeight) || (tetrX+x+xm<0 || tetrX+x+xm>=gridWidth)) {
        gridC=1;
      } else {
/*        if (xm!=0) {
          gridC=grid[tetrX+x+xm][tetrY+y];
        } else if (ym!=0) {
          gridC=grid[tetrX+x][tetrY+y+ym];
        } else if (ym==0 && xm==0) {
          gridC=grid[tetrX+xm][tetrY+y+ym];
        } */
        gridC=grid[tetrX+x+xm][tetrY+y+ym];
      }

      if (debug) System.out.print(gridC + " ");
      if (gridC!=0 && gridTemplate[tetrType][tetrR][y][x]!=0) moveOK=false;
    }
    if (debug) System.out.println();
  }
  
  return moveOK;
  
}

// Check if rotation will move tetrimino outside the grid
public boolean tetrCheckRotate(int rm) {
  boolean rotateOK=false;
  int x = tetrPosX;
  int y = tetrPosY;
  int tetrR = tetrRot+rm;
  if (tetrR==4) tetrR=0;
  if (tetrR==-1) tetrR=3;

//  for (int i=0; i<3; i++) {
    rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    if (!rotateOK) System.out.println(rotateOK);
    if (!rotateOK && tetrCheckMove(-1,0,x,y,tetrR)) {
        x--;
        rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    }
        
    if (!rotateOK && tetrCheckMove(-2,0,x,y,tetrR)) {
        x=x-2; 
        rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    }

    if (!rotateOK && tetrCheckMove(+1,0,x,y,tetrR)) {
        x++;
        rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    }

    if (!rotateOK && tetrCheckMove(+2,0,x,y,tetrR)) {
        x=x+2;
        rotateOK = tetrCheckMove(0, 0, x, y, tetrR);
    }
//  }
  
  if (rotateOK) tetrPosX=x;
  
  return rotateOK;
}

// Check grid for full lines
public void gridCheck() {

  for (int y=0;y<gridHeight;y++) {
    removeLine=true;

   
   
    for (int x=0;x<gridWidth;x++) {
      if (grid[x][y]==0) { removeLine=false; fade=0; break;}
    }
    
    // Remove full line //////enlever une ligne////////////////////
    if (removeLine  ) {

      ligne.trigger();
       _line+=1;
       _score+=1000;
       speedDelay-=50;
       //
 OscMessage myMessage = new OscMessage("/score");
myMessage.add(1000);
  oscP5.send(myMessage, myRemoteLocation); 
   OscMessage myMessage2 = new OscMessage("/line");
myMessage2.add(1);
  oscP5.send(myMessage2, myRemoteLocation); 
       OscMessage myMessage3 = new OscMessage("/nrv");
myMessage3.add(PApplet.parseInt(random(9)));
  oscP5.send(myMessage3, myRemoteLocation); 
      
   

  
   println (tetrPosX+ " "+y +" "+gridWidth +" "+gridHeight);
   //
 
      for (int yi=y;yi>0;yi--) {
        for (int xi=0;xi<gridWidth;xi++) {
          
           grid[xi][yi]=grid[xi][yi-1];
        }
      }
      for (int xi=0;xi<gridWidth;xi++) {
        grid[xi][0]=0;



      }

  
    }

  }
  }
  //////////////////////////////////////////////////////////

// Fix tetrimino to grid
public void tetrFixToGrid() {

  for(int y=0;y<tetrSize;y++) {
    for(int x=0;x<tetrSize;x++) {
      if (debug) System.out.print(gridTemplate[tetrType][tetrRot][y][x]+ "!");
      if (gridTemplate[tetrType][tetrRot][y][x]!=0) {
        grid[tetrPosX+x][tetrPosY+y]=gridTemplate[tetrType][tetrRot][y][x];
      }
    }
    if (debug) System.out.println("");
  }
}

// Set new tetrimino
public void tetrNew() { 
  int type=tetrQueue[0];
  for(int i=0;i<maxQueue-1;i++) {
    tetrQueue[i]=tetrQueue[i+1];
  }
  tetrQueue[maxQueue-1]=round(random(0,6));

  tetrNew(type);  
}

public void tetrNew(int type) {
  tetrType=type;
  if (tetrType==0 || tetrType==3) tetrSize=4; else tetrSize=3;

  tetrRot=0;
  tetrPosY=0;
  tetrPosX=PApplet.parseInt(gridWidth/2)-(tetrSize-1);
}

// Process input
public void keyPressed() {
     char k;

  k = (char)key;

  switch(k){
    
  case 8:

    if(buff.length()>0){
      buff = buff.substring(1);
    }
break;






      
 // case 13:  // Avoid special keys
 // case 10:
 // case 65535:
 // case 127:
 // case 27:
   // break;
  default:
  
  
    if(textWidth(buff+k)+leftmargin < width-rightmargin){
      didntTypeYet = false;

   if (nb_buff==9){   
      buff=k+buff;
   }
   
   if (nb_buff!=9){      
     buff=bullshit[nb_buff];

 }


 
    }
    break;
  }
  
  
 
    // MOVE LEFT
            if (key == ENTER || key == RETURN){
         nb_buff=9;
console.retour_a_la_ligne();
      console.controle();
    }
     if (!tetrLocked) {
    if (_debug){
    
    if (keyCode==LEFT) {
      if (debug) System.out.println("--- " + tetrPosX + " " + tetrPosY);          
      if (tetrCheckMove(-1,0)) tetrPosX--;
    }
    
    // MOVE RIGHT
    if (keyCode==RIGHT && tetrCheckMove(1,0)) tetrPosX++;
  
    // DOWN
    if (keyCode==DOWN) tetrDownStep=true;
    
    // UP
    if (keyCode==UP) tetrDrop=true;

    // SAVE TETRIMINO
   // if ((key=='w' || key=='W') && tetrCanSave) tetrSave();
    
    // ROTATE LEFT
   // if ((key=='q' || key=='Q') && tetrCheckRotate(-1)) { tetrRot--; timer = millis(); }
    
    // ROTATE RIGHT
 //   if ((key=='e' || key=='E') && tetrCheckRotate(+1)) { tetrRot++; timer = millis(); }
 
    
    if (tetrRot==4) tetrRot=0;
    if (tetrRot==-1) tetrRot=3;
  }
     }
}

// Render grid and tetrimino to screen
public void renderGrid() {
 // stroke(55);
  
  for(int x=0;x<gridWidth;x++) {
    for(int y=0;y<gridHeight;y++) {
        switchFillColor(grid[x][y]);
      //  rect(gridStartX+x*rectWidth,gridStartY+(y-gridHidden)*rectHeight,rectWidth,rectHeight);
     image(c, gridStartX+x*rectWidth,gridStartY+(y-gridHidden)*rectHeight);
       // fill(0,128);
         //       rect(3+gridStartX+x*rectWidth,3+gridStartY+(y-gridHidden)*rectHeight,rectWidth-6,rectHeight-6);
    }
  }  
  
  // render shadow
//  renderShadow();
  
  // render tetrimino
  for(int y=0;y<tetrSize;y++) {
    for(int x=0;x<tetrSize;x++) {
      if (gridTemplate[tetrType][tetrRot][y][x]!=0 && y+tetrPosY>=gridHidden) {
       noTint();
        switchFillColor(gridTemplate[tetrType][tetrRot][y][x]);
        //rect(gridStartX+(x+tetrPosX)*rectWidth,gridStartY+((y+tetrPosY-gridHidden)*rectHeight),rectWidth,rectHeight);
         image (c,gridStartX+(x+tetrPosX)*rectWidth,gridStartY+((y+tetrPosY-gridHidden)*rectHeight));
         // fill(0,128);
           //   rect(3+gridStartX+(x+tetrPosX)*rectWidth,3+gridStartY+((y+tetrPosY-gridHidden)*rectHeight),rectWidth-6,rectHeight-6);
    }
    }
  }
  
}

public void switchFillColor(int c) {
  switch (c) {
    case 0: tint(0,0,0); break;
    case 1: tint(0,255,255); break;
    case 2: tint(0,0,255); break;
    case 3: tint(255,165,0); break;
    case 4: tint(255,255,0); break;
    case 5: tint(0,255,0); break;
    case 6: tint(148,0,211); break;
    case 7: tint(255,0,0); break;
    default: tint(255); break;
  }
}

_hiScore _hiscore = new _hiScore ();
 String[]displayScore;

class _hiScore{
  
   public void loadScore(){
    displayScore=loadStrings("score.txt");
    displayScore =sort (displayScore);
  displayScore=  reverse (displayScore);

  if ((displayScore.length)>10){
    displayScore=shorten (displayScore);
    
  }
 
    println (displayScore);
    
  }
   public void draw(){
     fill(0);
     rect(40,20,200,460);
          
              fill(0,255,0);
   text ("HIGH SCORE",70,50);
     for (int i=0; i<displayScore.length; i++){
     text(displayScore[i],45,100+(20*i));
    }
}
}
Duree duree= new Duree();

int display_type=1;

class Duree extends TimerTask {

  Timer timer;

  Duree () {
    timer = new Timer();
    timer.scheduleAtFixedRate(this, 0,60000); 

  }

  public void run() {
    if (display_type==1){
      display_type=0; 


}  
    else{
      _hiscore.loadScore(); 
      display_type=1; 
    }

  }

}


Console console = new Console ();
int leftmargin = 10;
int rightmargin = 20;
String buff = "";
boolean didntTypeYet = true;
boolean go,display,_debug,display3,name,display4,bluff;
String[] liste=new String [25];
String[] nom_score={""};
String[] bullshit={"ehcuag","etiord","enruot","ebmot","edia","enruot ","foraine","surtolam", "niterc"};
String [] nom_score2;
int okboy,id_buff;
boolean reco;
int _ligne=-1,nb_partie=-1,action=-1;
int nb_buff=9;
String[] verif= {
  "ehcuag","etiord","enruot","ebmot","edia","enruot ","nu","gubed","2=+enruot","3=+enruot","++i 2<i 0 = i tni rof","++i 3<i 0 = i tni rof",
"2=+etiord","2=+ehcuag","vontijap iexela","xued"};

//String[] verif= {
//  "gauche","droite","tourne","tombe","aide"," tourne","oui","debug","tourne+=2","tourne+=3","tourne-=2","tourne-=3","for int i=0 i<2 i++","for int i=0 i<3 i++",
//"for int i=0 i<2 i--","for int i=0 i<3 i--","alexei pajitnov"};


String buff_nom3;

class Console{
  int text_y=20;
  public void retour_a_la_ligne(){
    String buff4;


    StringBuffer buff3 = new StringBuffer(buff).reverse();
    text_y+=15;
    _ligne+=1;

    buff4=buff3.toString().trim();
    liste[_ligne]=buff4;
    if (_ligne>=23){

      text_y=20; 
      String[] liste=new String [25];
      _ligne=-1;
    }


  }
  ////////////////////////////////////
  /////////////////////////////////////
  
  
  
  
  public void gameOver(){
    
    go=true;
  
    if (display){
   _ligne+=1;
      text_y+=15;
  liste[_ligne]="GAME OVER ";
start=true;
gameOver2=true;
display3=true;

display=false;  
    }
  if (display3){
    _ligne+=1;
      text_y+=15;
  liste[_ligne]="Entrer votre nom:";
  nb_partie+=1;
   gameOver2=false;
   name=true;
   display3=false;
    
 }
    
  }
  public void startGame(){
 if (gameOver && start){
 if(display_type==0){
    image (a,40,20);
    }else{ 
    _hiscore.draw();
    }
    }
    if (display2 && !name){
        _ligne+=1; 
  text_y+=15;
  liste[_ligne]="Combien de joueurs [un] ou [deux]?";
      display2=false;

    }
 
 
     
  }
  
  
  public void controle(){

    String buff2;
    buff2=buff.trim();

    buff=" ";

   if (!name){
    if (!go ){
//gauche
println (buff2);
/*
 pattern = Pattern.compile(verif[8], Pattern.CASE_INSENSITIVE);
 matcher = pattern.matcher(buff2);


if (matcher.find()){
  println (matcher);
 tetrRot++; tourne.trigger();
      timer = millis(); 
reco=true;
}
*/



    if (buff2.equals(verif[0]) ){

 if (debug) System.out.println("--- " + tetrPosX + " " + tetrPosY);          
if (tetrCheckMove(-1,0)) tetrPosX--; move.trigger();

    }
        else if (buff2.equals(verif[8]) || buff2.equals(verif[10])  && tetrCheckRotate(+2)){ 
     tetrRot+=2; tourne.trigger();
      timer = millis(); 
    }
            else if (buff2.equals(verif[9]) || buff2.equals(verif[11]) && tetrCheckRotate(+3)){ 
     tetrRot+=3; tourne.trigger();
      timer = millis(); 
    }

                    else if (buff2.equals(verif[12]) && tetrCheckMove(2,0)){ 
     tetrPosX+=2; move.trigger();

    }
                    else if (buff2.equals(verif[13]) && tetrCheckMove(-2,0)){ 
     tetrPosX-=2; move.trigger();

    }
                        else if (buff2.equals(verif[14]) ){ 
    
            _score+=10000;

    }
    else if (buff2.equals(verif[1])  && tetrCheckMove(1,0)){ 
     tetrPosX++;move.trigger();
    }
    else if (buff2.equals(verif[2]) || buff2.equals(verif[5]) && tetrCheckRotate(+1)) { 
      tetrRot++; tourne.trigger();
      timer = millis(); 
    }
   




    else if (buff2.equals(verif[3])){
      tetrDrop=true;
      _score+=100;


    }
        else if (buff2.equals(verif[7])){
      _debug=true;

    }
    
    else if (buff2.equals(verif[4])){
      _ligne+=1;
      text_y+=15;
      liste[_ligne]="Aide: ";     
_ligne+=1;
      text_y+=15;
      liste[_ligne]="<gauche  > d\u00e9placer \u00e0 gauche";     
_ligne+=1;
      text_y+=15;
      liste[_ligne]="<droite  > d\u00e9placer \u00e0 droite";     
      _ligne+=1;
      text_y+=15;
      liste[_ligne]="<tourne  > faire tourner la pi\u00e8ce";   
            _ligne+=1;
      text_y+=15;
      liste[_ligne]="<tombe   > faire chuter la pi\u00e8ce"; 
    }
       //liste[_ligne]="<gauche  > d\u00e9placer \u00e0 gauche\n <droite  > d\u00e9placer \u00e0 droite\n <tourne  > faire tourner la pi\u00e8ce \n <tombe   > faire chuter la pi\u00e8ce";     
    else if (!buff2.equals(verif[3])|| !buff2.equals(verif[2])|| !buff2.equals(verif[1])|| !buff2.equals(verif[0]) ){  
      _ligne+=1;
      text_y+=15;
      liste[_ligne]="D\u00e9sol\u00e9, je ne comprends pas";   
      

  Toolkit.getDefaultToolkit().beep();

      _score-=200;

      if (_score<=0)_score=0;  
    }
    if (tetrRot==4) tetrRot=0;
    if (tetrRot==-1) tetrRot=3;
  }else if (buff2.equals(verif[6])){   gameOver=false;  go=false;  text_y=35;  tetrLocked=false; _score=0; _ligne=0; speedDelay=1000;
 grid = new int[gridWidth][gridHeight];
  for (int x=0;x<gridWidth;x++) {
    for (int y=0;y<gridHeight;y++) {
      grid[x][y]=0;
    }
  }
    tetrQueue = new int[maxQueue];
  for(int i=0;i<maxQueue;i++) {
    tetrQueue[i]=round(random(0,6));
  }
tetrNew(); 

}else if (buff2.equals(verif[15])){ _ligne+=1;
      text_y+=15;
      liste[_ligne]="En attente du 2\u00e8me joueur...";  
    OscMessage myMessage = new OscMessage("/available");
myMessage.add(1);
  oscP5.send(myMessage, myRemoteLocation); 
  
 
    if (okboy==1){  
     ///tout est ok
         myMessage = new OscMessage("/available");
myMessage.add(1);
      gameOver=false;  go=false;  text_y=35;  tetrLocked=false; _score=0; _ligne=0; speedDelay=1000;
 grid = new int[gridWidth][gridHeight];
  for (int x=0;x<gridWidth;x++) {
    for (int y=0;y<gridHeight;y++) {
      grid[x][y]=0;
    }
  }
    tetrQueue = new int[maxQueue];
  for(int i=0;i<maxQueue;i++) {
    tetrQueue[i]=round(random(0,6));
  }
tetrNew();    }else{
 myMessage = new OscMessage("/available");
myMessage.add(1);
 
} 
  
  
  } Toolkit.getDefaultToolkit().beep();
 }
    //pour \u00e9viter d'enregistrer un score nul

if (go && name  ){
//if (_score!=0){
 
//buff2=buff2.substring(0,10);
  //println (buff2);
StringBuffer buff_nom = new StringBuffer(buff2).reverse();
String buff_nom2= buff_nom.toString();
 if (buff_nom2.length() >= 8){
buff_nom2=buff_nom2.substring(0,8);
}

//String _score_3="";
int _score_2=PApplet.parseInt(random(5000));
 //_score_2= Integer.valueOf(_score_3);
String _score_3=String.valueOf(_score);
if (_score_3.length()==4){ _score_3="0"+_score_3;}
if (_score_3.length()==3){ _score_3="00"+_score_3;}



buff_nom3=buff_nom2.substring(0,3);

String nom_score3=_score+" "+buff_nom2;
println (nom_score3);
 output.println(nom_score3);
output.flush();

display2=true;
name=false;

} 
   
  }
  public void draw (){
        noTint();
    fill (0);
    rect (300,20,460,460);

    if((millis() % 500) < 250){  // Only fill cursor half the time
      noStroke();
      noFill();
    }
    else {
      noStroke();
      fill(0,255,0);

    }
    float rPos;
    // Store the cursor rectangle's position

    rPos = textWidth(buff) + leftmargin;

    rect(rPos+300, text_y+10, 10, 12);

    // Some instructions at first
    if(didntTypeYet) {
      fill(0);
      //text("Use the keyboard.", 22, 40);
    }
    pushMatrix();
    translate(rPos,0);
    char k;
    for(int i = 0;i < buff.length(); i++) {
      k = buff.charAt(i);
      translate(-textWidth(k),0);


      fill(0,255,0);
      text(k,300,20+text_y);

    } 
    popMatrix();
    for(int i = 0;i <_ligne+1; i++) {
      fill(0,255,0);
      text (liste[i],320,40+(i*15));
    }
  }
}
public void oscEvent(OscMessage messageEntrant) {
    // si on re\ufffdoit le bon type de message
  if (messageEntrant.addrPattern().equals("/available") == true) {
    
    // si on re\ufffdoit le bon nombre d'arguments et chacun du bon genre
 
      // r\ufffdcup\ufffdrer les deux integers (entiers) du message
      okboy = messageEntrant.get(0).intValue();
  }
   if (messageEntrant.addrPattern().equals("/score") == true) {

     _score2 = messageEntrant.get(0).intValue();

   
}
   if (messageEntrant.addrPattern().equals("/line") == true) {

     _line2 = messageEntrant.get(0).intValue();

      println (messageEntrant);
     } 
   if (messageEntrant.addrPattern().equals("/nrv") == true) {
    println (messageEntrant);
nb_buff= messageEntrant.get(0).intValue();
if (nb_buff!=7){        _ligne+=1; 
  console.text_y+=15;
  liste[_ligne]="Joueur 1 a fait 1 ligne";
}


   }
   
      if (messageEntrant.addrPattern().equals("/ok") == true) {

id_buff= messageEntrant.get(0).intValue();






   }
   }
final int gridTemplate[][][][] = {
  {{{0,0,0,0}, // I
    {1,1,1,1},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,0,1,0},
    {0,0,1,0},
    {0,0,1,0},
    {0,0,1,0}},
   {{0,0,0,0},
    {0,0,0,0},
    {1,1,1,1},
    {0,0,0,0}},
   {{0,1,0,0},
    {0,1,0,0},
    {0,1,0,0},
    {0,1,0,0}}},
  {{{2,0,0,0}, // J
    {2,2,2,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,2,2,0},
    {0,2,0,0},
    {0,2,0,0},
    {0,0,0,0}},
   {{0,0,0,0},
    {2,2,2,0},
    {0,0,2,0},
    {0,0,0,0}},
   {{0,2,0,0},
    {0,2,0,0},
    {2,2,0,0},
    {0,0,0,0}}},
  {{{0,0,3,0}, // L
    {3,3,3,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,3,0,0},
    {0,3,0,0},
    {0,3,3,0},
    {0,0,0,0}},
   {{0,0,0,0},
    {3,3,3,0},
    {3,0,0,0},
    {0,0,0,0}},
   {{3,3,0,0},
    {0,3,0,0},
    {0,3,0,0},
    {0,0,0,0}}},
  {{{0,4,4,0}, // O
    {0,4,4,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,4,4,0},
    {0,4,4,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,4,4,0},
    {0,4,4,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,4,4,0},
    {0,4,4,0},
    {0,0,0,0},
    {0,0,0,0}}},
  {{{0,5,5,0}, // S
    {5,5,0,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,5,0,0},
    {0,5,5,0},
    {0,0,5,0},
    {0,0,0,0}},
   {{0,0,0,0},
    {0,5,5,0},
    {5,5,0,0},
    {0,0,0,0}},
   {{5,0,0,0},
    {5,5,0,0},
    {0,5,0,0},
    {0,0,0,0}}},
  {{{0,6,0,0}, // T
    {6,6,6,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,6,0,0},
    {0,6,6,0},
    {0,6,0,0},
    {0,0,0,0}},
   {{0,0,0,0},
    {6,6,6,0},
    {0,6,0,0},
    {0,0,0,0}},
   {{0,6,0,0},
    {6,6,0,0},
    {0,6,0,0},
    {0,0,0,0}}},
  {{{7,7,0,0}, // Z
    {0,7,7,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,0,7,0},
    {0,7,7,0},
    {0,7,0,0},
    {0,0,0,0}},
   {{0,0,0,0},
    {7,7,0,0},
    {0,7,7,0},
    {0,0,0,0}},
   {{0,7,0,0},
    {7,7,0,0},
    {7,0,0,0},
    {0,0,0,0}}},
  {{{0,0,0,0}, // clear
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0}},
   {{0,0,0,0},
    {0,0,0,0},
    {0,0,0,0},
    {0,0,0,0}}}
};


/*


String input = "tourne?+=?2";

// Tell regex we're going to search for EAST or E
Pattern pattern = Pattern.compile("tourne\\?\\+\\=\\?2", Pattern.CASE_INSENSITIVE);
// Tell regex we want to look in the string "input"
Matcher matcher = pattern.matcher(input);

println(matcher.find()); 
*/

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#d4d0c8", "tetris_adventure_3_1_fr_part2" });
  }
}
